<?php /* -*- PHP -*- */

require ("library.php.inc");

init_hgrepos ();

/* unitary tests */

$data = do_unit_test ("");

file_write (HGREPOS . "/.htaccess", "Order allow,deny
Allow from all

Options ExecCGI
AddHandler cgi-script .cgi

RewriteEngine On
RewriteBase /hg2
RewriteRule ^$ hgweb.cgi [L]
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule (.*) hgweb.cgi/$1 [QSA,L]

AuthType Basic
AuthName \"Mercurial repositories\"
AuthBasicProvider ldap
#AuthUserFile tmp/password
AuthzLDAPAuthoritative on
AuthLDAPURL \"ldap://ldap.softndesign.org/ou=People,dc=softndesign,dc=org?uid?sub\"
AuthLDAPRemoteUserIsDN off
Require ldap-filter &(uid=*)");

file_write (HGREPOS . "/hgweb.config", "[collections]
/var/lib/hg = /var/lib/hg
[web]
style = gitweb");

file_write (".htaccess", "Order allow,deny
Allow from all

AuthType Basic
AuthName \"Mercurial HeadQuarter\"
AuthBasicProvider file
AuthUserFile tmp/password
#AuthLDAPURL \"ldap://ldap.softndesign.org/ou=People,dc=softndesign,dc=org?uid?sub\"
Require valid-user
require user mazet
");

$xml_data = create_xml_config ();

/* Unitary checks */

$stack = import_xml ($xml_data);

if (count ($stack) != 1) exit (1);

if (!array_key_exists("xml", $stack)) exit (1);
if (count ($stack["xml"]) != 1) exit (1);

if (!array_key_exists("config", $stack["xml"])) exit (1);
if (count ($stack["xml"]["config"]) != 10) exit (1);

if (!array_key_exists("root", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["root"]) != 1) exit (1);
if (!array_key_exists("name", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["name"]) != 1) exit (1);
if (!array_key_exists("logfile", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["logfile"]) != 1) exit (1);
if (!array_key_exists("loglevel", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["loglevel"]) != 1) exit (1);
if (!array_key_exists("style", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["style"]) != 1) exit (1);
if (!array_key_exists("auth", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["auth"]) != 1) exit (1);
if (!array_key_exists("authfile", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["authfile"]) != 1) exit (1);
if (!array_key_exists("authldaphost", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["authldaphost"]) != 1) exit (1);
if (!array_key_exists("authldaprequest", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["authldaprequest"]) != 1) exit (1);
if (!array_key_exists("admin", $stack["xml"]["config"])) exit (1);
if (count ($stack["xml"]["config"]["admin"]) != 1) exit (1);

print ("stack:\n");
print_r ($stack);

$orig = array ("root" => array("tmp/hg"),
               "name" => array("hg2"),
               "logfile" => array("tmp/logging.log"),
               "loglevel" => array(3),
               "style" => array("gitweb"),
               "auth" => array("ldap"),
               "authfile" => array("tmp/password"),
               "authldaphost" => array("ldap.softndesign.org"),
               "authldaprequest" => array("ou=People,dc=softndesign,dc=org"),
               "admin" => array ("mazet"));

for ($i = 0; $i < 1; $i++) {
    echo "repos: $i\n";
    foreach (array ("root", "name", "logfile", "loglevel", "style", "auth", "authfile", "authldaphost", "authldaprequest") as $key) {
        if ((!isset ($orig[$key][$i])) && (!isset($stack["xml"]["config"][$key][$i])))
            continue;
        echo " key: $key\n";
        if (strcmp ($stack["xml"]["config"][$key][$i], $orig[$key][$i]) != 0) exit (1);
    }
}

exit (0);
?>