<?php /* -*- PHP -*- */

@passthru ("rm config.inc.php");
@passthru ("rm .htaccess");

require ("library.php.inc");

init_hgrepos ();

_file_write ("config.inc.php", "<?php /* -*- PHP -*- */
/* Mercurial repository root */
define ('HGREPOS', 'tmp/hg');
/* Log file name */
define ('LOGFILE', 'tmp/logging.log');
/* Log level */
define ('LOGLEVEL', 3);
?>");

_file_write (HGREPOS . "/hgweb.cgi", "#!/usr/bin/env python
config = 'hgweb.config'
from mercurial import demandimport; demandimport.enable()
from mercurial.hgweb import hgweb, wsgicgi
application = hgweb(config)
wsgicgi.launch(application)
");

_file_write (HGREPOS . "/hgweb.config", "[collections]
tmp/hg = tmp/hg

[web]
style = gitweb
push_ssl = false
baseurl = /hg
");

_file_write (HGREPOS . "/.htaccess", "Order allow,deny
Allow from all

Options ExecCGI FollowSymLinks
AddHandler cgi-script .cgi

RewriteEngine On
RewriteBase /hg
RewriteRule ^$ hgweb.cgi [L]
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule (.*) hgweb.cgi/$1 [QSA,L]

AuthType Basic
AuthName \"Mercurial repositories\"
AuthBasicProvider file
AuthUserFile tmp/password
#AuthLDAPURL \"ldap://ldap.softndesign.org/ou=People,dc=softndesign,dc=org?uid?sub\"
Require valid-user
");

_file_write (".htaccess", "Order allow,deny
Allow from all

AuthType Basic
AuthName \"Mercurial HeadQuarter\"
AuthBasicProvider file
AuthUserFile tmp/password
#AuthLDAPURL \"ldap://ldap.softndesign.org/ou=People,dc=softndesign,dc=org?uid?sub\"
Require valid-user
require user mazet
");

/* unitary tests */

$_POST = array ("action" => "config", "root" => HGREPOS, "name" => "hg", "logfile" => "tmp/logging-2.log", "loglevel" => 2, "style" => "gitweb", "auth" => "file", "authfile" => "tmp/password", "authldaphost" => "ldap.softndesign.org", "authldaprequest" => "ou=People,dc=softndesign,dc=org", "admin" => "mazet");

$data = do_unit_test ("<xml><message><text><![CDATA[Configuration updated]]></text><stat>0</stat></message></xml>",
                      null,
                      array ("config.inc.php" => "f08bc57faf088a9413382df556d8537f"));

/* Unitary checks */

passthru ("rm config.inc.php");
passthru ("rm .htaccess");

exit (0);
?>